﻿Imports Telerik.Windows.Controls
Imports Telerik.Windows.Controls.Gauges
Imports Telerik.Windows.Controls.Navigation

Class MainWindow
    Inherits Window

    Private rangeGreen As RadialRange
    Private rangeRed As RadialRange
    Private rangeYellow As RadialRange
    Private scale As RadialScale
    Private needle As Needle
    Private marker As Marker

    'Public Sub New()

    '    InitializeComponent()

    '    AddHandler Loaded, AddressOf Control_Loaded
    'End Sub

    'Private Sub Control_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)

    '    ' create the RadGauge    
    '    Dim radGauge = New Telerik.Windows.Controls.RadGauge()

    '    ' add RadGauge to the LayoutRoot    
    '    LayoutRoot.Children.Add(radGauge)

    '    ' create the RadialGauge    
    '    Dim gauge = New RadialGauge()

    '    ' add RadialGauge to the RadGauge    
    '    radGauge.Content = gauge


    '    ' create the RadialScale    
    '    scale = New RadialScale()
    '    scale.Name = "scale"
    '    scale.Min = 0
    '    scale.Max = 100
    '    scale.MinorTicks = 2
    '    scale.MiddleTicks = 2
    '    scale.Radius = 0.75

    '    ' add RadialScale to the RadialGauge    
    '    gauge.Items.Add(scale)

    '    'Create ranges
    '    Dim rangeList = New RangeList()
    '    scale.Items.Add(rangeList)

    '    'Create the Range Green   
    '    rangeGreen = New RadialRange()
    '    rangeGreen.Name = "Green"
    '    rangeGreen.StartWidth = 0.06
    '    rangeGreen.EndWidth = 0.06
    '    rangeGreen.Min = 0
    '    rangeGreen.Max = 50
    '    rangeGreen.Background = New SolidColorBrush(Colors.Green)

    '    scale.Ranges.Add(rangeGreen)

    '    'Create the Range Yellow   
    '    rangeYellow = New RadialRange()
    '    rangeYellow.Name = "Yellow"
    '    rangeYellow.StartWidth = 0.06
    '    rangeYellow.EndWidth = 0.06
    '    rangeYellow.Min = 50
    '    rangeYellow.Max = 85
    '    rangeYellow.Background = New SolidColorBrush(Colors.Yellow)
    '    scale.Ranges.Add(rangeYellow)

    '    'Create the Range Red   
    '    rangeRed = New RadialRange()
    '    rangeRed.Name = "Red"
    '    rangeRed.StartWidth = 0.06
    '    rangeRed.EndWidth = 0.06
    '    rangeRed.Min = 85
    '    rangeRed.Max = 100
    '    rangeRed.Background = New SolidColorBrush(Colors.Red)
    '    scale.Ranges.Add(rangeRed)


    '    Dim IndicatorList1 = New IndicatorList()
    '    scale.Items.Add(IndicatorList1)
    '    ' create the Needle    
    '    needle = New Needle()
    '    needle.Value = 30
    '    ' add needle to indicators collection    
    '    scale.Indicators.Add(needle)

    '    ' create the marker
    '    marker = New Marker()
    '    marker.Value = 80
    '    ' add marker to indicators collection    
    '    scale.Indicators.Add(marker)

    '    'Dim TickList1 = New TickList()

    '    'Dim CustomTick = New CustomTickMark()
    '    'CustomTick.Value = 50
    '    'TickList1.Items.Add(CustomTick)
    '    'scale.Items.Add(TickList1)

    '    Dim tl As New TickList
    '    tl.Name = "ticklist"
    '    Dim ctm As New CustomTickMark
    '    ctm.Value = 50
    '    ctm.Name = "CustomTickMark"
    '    'ctm.Template = GetInternalLabel()

    '    tl.Items.Add(ctm)
    '    scale.Items.Add(tl)



    'End Sub

    'Private Function GetInternalLabel() As ControlTemplate
    '    Dim l As FrameworkElementFactory = New FrameworkElementFactory(GetType(TextBlock))
    '    'l.SetValue(Ellipse.FillProperty, Brushes.AliceBlue)
    '    'l.SetValue(Ellipse.MarginProperty, New Thickness(2))
    '    l.SetValue(TextBlock.TextProperty, "Test")


    '    Dim cv As FrameworkElementFactory = New FrameworkElementFactory(GetType(Canvas))

    '    'grid.SetValue(Grid.MarginProperty, new Thickness(5));


    '    cv.AppendChild(l)


    '    Dim ct As New ControlTemplate(GetType(CustomTickMark))

    '    'Dim cp As New ContentPresenter
    '    'cp.Name = "cp" & gauges.Count.ToString
    '    ''Dim cv As New Canvas
    '    ''cv.Name = "cv" & gauges.Count.ToString
    '    'cp.Content = cv
    '    ''Dim l As New TextBlock
    '    ''l.Name = "label" & gauges.Count.ToString
    '    ''l.Text = "test"
    '    ''cv.Children.Add(l)

    '    ct.VisualTree = l


    '    Return ct
    'End Function

    Private Sub MainWindow_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        AddRadialGauge()
    End Sub

    Private Sub AddRadialGauge()
        Dim scale As RadialScale
        Dim needle As Needle
        Dim sp As New StackPanel
        sp.Orientation = Orientation.Vertical

        Dim radGauge = New Telerik.Windows.Controls.RadGauge()
        radGauge.Name = "dashboardGauge"
        radGauge.Width = 250
        radGauge.Height = 250
        sp.Width = 250
        sp.Height = 250
        sp.Children.Add(radGauge)

        bgGrid.Children.Add(sp)

        Canvas.SetLeft(sp, 200)
        Canvas.SetTop(sp, 200)

        Dim gauge = New RadialGauge()

        radGauge.Content = gauge

        scale = New RadialScale()
        scale.Name = "scale"
        scale.Min = 0
        scale.Max = 180
        scale.MinorTicks = 4
        scale.MiddleTicks = 4
        scale.MajorTicks = 10
        scale.Radius = 0.65

        gauge.Items.Add(scale)

        Dim tl As New TickList
        tl.Name = "ticklist" ' & gauges.Count.ToString
        Dim ctm As New CustomTickMark
        ctm.Name = "CustomTickMark" ' & gauges.Count.ToString
        ctm.Value = 50
        ctm.Template = GetInternalLabel()

        tl.Items.Add(ctm)
        scale.Items.Add(tl)




        Dim IndicatorList1 = New IndicatorList()
        scale.Items.Add(IndicatorList1)

        needle = New Needle()
        needle.Name = "Needle"

        scale.Indicators.Add(needle)
        Me.RegisterName(needle.Name, needle)
    End Sub

    Private Function GetInternalLabel() As ControlTemplate
        Dim l As FrameworkElementFactory = New FrameworkElementFactory(GetType(TextBlock))
        l.SetValue(TextBlock.TextProperty, "Test")

        Dim cv As FrameworkElementFactory = New FrameworkElementFactory(GetType(Canvas))

        cv.AppendChild(l)

        Dim ct As New ControlTemplate(GetType(CustomTickMark))

        ct.VisualTree = l

        Return ct
    End Function
End Class
 